unit Flag;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls;

type

  TNation = ( nUSA, nUK, nFrance, nUSSR, nNaziGermany, nJapanOld, nItaly, nCanada );
  TNationSet = set of TNation;

  TFlag = class(TImage)
  private
     FNation: TNation;
  protected
     procedure SetNation( nArg: TNation );
  public
     constructor Create( AOwner: TComponent ); override;
  published
     property Nation: TNation read FNation write SetNation;
  end;

function NationFlag( const n: TNation ): TBitmap;

procedure Register;

implementation

{$R FLAGBMP}

var
  bmpFlag: array[nUSA..nCanada] of TBitmap;

constructor TFlag.Create( AOwner: TComponent );
begin
  inherited Create( AOwner );
  AutoSize := TRUE;
  FNation := nUSA;
end;

procedure Register;
begin
  RegisterComponents( 'SilCmd', [TFlag] );
end;

procedure TFlag.SetNation( nArg: TNation );

  procedure LoadFlag( const n: TNation; const sName: string );
  var
     lpName: PChar;
  begin
     bmpFlag[n] := TBitmap.Create;
     lpName := StrAlloc( Length( sName ) + 1 );
     StrPCopy( lpName, sName );
     bmpFlag[n].Handle := LoadBitmap( hInstance, lpName );
     StrDispose( lpName );
  end;

begin
  if bmpFlag[nUSA] = nil then
     begin
        LoadFlag( nUSA, 'USA' );
        LoadFlag( nUK, 'UK' );
        LoadFlag( nFrance, 'FRANCE' );
        LoadFlag( nUSSR, 'USSR' );
        LoadFlag( nNaziGermany, 'NAZIGERMANY' );
        LoadFlag( nJapanOld, 'JAPANOLD' );
        LoadFlag( nItaly, 'ITALY' );
        LoadFlag( nCanada, 'CANADA' );
     end;
  FNation := nArg;
  Picture.Graphic := bmpFlag[FNation];
end;

function NationFlag( const n: TNation ): TBitmap;
begin
  Result := bmpFlag[n];
end;

initialization

bmpFlag[nUSA] := nil;

end.
